Attribute VB_Name = "codeComm"
Option Explicit

Public CommFlag As Boolean
'communications parameters
Public CommType As Long
Public CommNum As Long
Public CommBaud As Long
' network address variables
Public Host As Long
Public Target As Long
Public Timeout As Long
Public ConnectID As Long
Public TargetIPs As String
Public TargetIP As Long

Public CtModel As Long
Public IsEA As Boolean

Declare Function inet_addr Lib "wsock32.dll" _
    (ByVal ipAddress As String) As Long

Function CheckComm() As Boolean
'check for communication with controller
On Error GoTo BADCOMM:
Dim R As Long
    'close network if needed
    If ConnectID <> 0 Then
        If CtCloseConnection(ConnectID) <> SUCCESS Then GoTo BADCOMM
        ConnectID = 0
    End If
    
    'open connection
    If CommType = CTCNET Then
        'open network connection
        ConnectID = CtOpenConnection(CTCNET, Host, Target)
        If ConnectID = 0 Then
            MsgBox "Failed to open Network connection. Check communications setup", vbExclamation
            GoTo BADCOMM
        End If
    ElseIf CommType = CTCUDP Then
        'open TCP Connection
        TargetIP = inet_addr(TargetIPs)
        If TargetIP = -1 Then
            MsgBox ("Invalid Controller IP Address")
            CheckComm = False
            Exit Function
        End If
        ConnectID = CtOpenConnection(CTCTCP, 0, TargetIP)
        If ConnectID = 0 Then
            MsgBox "Failed to open TCP connection. Check communications setup.", vbExclamation
            GoTo BADCOMM
        End If
    ElseIf CommType = CTCTCP Then
        'open UDP Connection
        TargetIP = inet_addr(TargetIPs)
        If TargetIP = -1 Then
            MsgBox ("Invalid Controller IP Address")
            CheckComm = False
            Exit Function
        End If
        ConnectID = CtOpenConnection(CTCUDP, 0, TargetIP)
        If ConnectID = 0 Then
            MsgBox "Failed to open UDP connection. Check communications setup.", vbExclamation
            GoTo BADCOMM
        End If
    Else
        'open serial connection
        ConnectID = CtOpenConnection(SERIAL, CommNum, 0)
        If ConnectID = 0 Then
            MsgBox "Failed to open serial port. Check communications setup.", vbExclamation
            GoTo BADCOMM
        End If
        'configure serial port
        If CtInitConnection(ConnectID, CommBaud, NO_PARITY, EIGHT_DATA_BITS, ONE_STOP_BITS) <> 1 Then
            MsgBox "Failed to initialize serial port. Check communications setup.", vbExclamation
            GoTo BADCOMM
        End If
    End If
    
    'set timeout
    If CtSetConnectionTimeout(ConnectID, Timeout) <> SUCCESS Then
        MsgBox "Failed to set timeout.", vbExclamation
    End If
    
    'get controller model
    If CtGetModel(ConnectID, CtModel, IsEA) = 1 Then
        CheckComm = True
    Else
        'Call DisplayError("No response from controller. Check communications setup." & vbLf)
        CheckComm = False
    End If
    Exit Function
    
'*********
BADCOMM:
    If ConnectID <> 0 Then
        R = CtCloseConnection(ConnectID)
        ConnectID = 0
    End If
    
    CheckComm = False
    Exit Function
    
End Function
